


#include <openGLCD.h>

//Simple fuel gauges for my Thorp T-18 aircraft with ks0108 based LCD 128x64 (Green or white ones are sunlight readable)
// email me if you have a better version flydr2@gmail.com
//This is still work in progress... I've made this public as a guide line for others, use at your own risk.
//I used a Feadruino mega
// left and right wing tanks use potentiometer type fuel gauge
//center one needed a voltage divider or a differant gauge
//Fuel pressure needed a voltage divider
//Set your own map fuction settings
//Since I transfer fuel from the left and right tank to the main. I've setup Warning lights. Left or right to a min and canter to a max
// email me if you have a better version of this code flydr2@gmail.com
//I'm not a programmer just someone who likes to learn


int RsensorPin = A0;    // Right Fuel Sensor
int RsensorValue = 0;  // variable to store the value coming from the sensor
int RGallon = 0;  //Right fuel in Gallons


int LsensorPin = A1;    // LEFT Fuel Sensor
int LsensorValue = 0;  // variable to store the value coming from the sensor
int LGallon = 0;  //Left fuel in Gallons

int CsensorPin = A2;    // center Fuel Sensor
int CsensorValue = 0;  // variable to store the value coming from the sensor
int CGallon = 0;  //center fuel in Gallons

int FsensorPin = A3;    // Pressure Fuel Sensor
int FsensorValue = 0;  // variable to store the value coming from the sensor
int PSI = 0;  //Fuel pressure

int leftWarnPin =  12; //wanrning light pins
int centerWarnPin =  11;
int rightWarnPin =  10;


float totalfuel = 0;
float totalhrs = 0;

gText textAreaTotal;
gText textAreaFuel;
gText textAreaRT;
gText textAreaRGal;
gText textAreaCT;
gText textAreaCGal;
gText textAreaLT;
gText textAreaLGal;
gText textAreaPSI;
gText textAreaPRES;
gText textAreaEND;
gText textAreaHours;





void setup()
{ 
  // Initialize the GLCD 
  GLCD.Init();
  GLCD.ClearScreen();



  

//Right tank*****************************

  // 115pixel from left, 1 pixel from top, 2 columns, 1 line
  textAreaRT.DefineArea(115, 1, 2, 1 , newbasic3x5);
  textAreaRT.print("RT");

   // 110pixel from left, 47 pixel from top, 2 columns, 1 line
   
  textAreaRGal.DefineArea(110, 47, 2, 1, fixednums7x15);
  

  GLCD.DrawRect(108,0,20,64); //Draw the area
  pinMode(rightWarnPin, OUTPUT); //pn mode for light
  digitalWrite(rightWarnPin, LOW); //turn pin to low

//CENTER tank*****************************

 // 92 pixel from left, 1 pixel from top, 2 columns, 1 line
  textAreaCT.DefineArea(92, 1, 2, 1 , newbasic3x5);
  textAreaCT.print("CT");

   // 87pixel from left, 47 pixel from top, 2 columns, 1 line
   
  textAreaCGal.DefineArea(87, 47, 2, 1, fixednums7x15);
  

  GLCD.DrawRect(85,0,20,64); //Draw the area
  pinMode(centerWarnPin, OUTPUT); //pn mode for light
  digitalWrite(centerWarnPin, LOW); //turn pin to low

//LEFT tank*****************************

 // 69 pixel from left, 1 pixel from top, 2 columns, 1 line
  textAreaLT.DefineArea(69, 1, 2, 1 , newbasic3x5);
  textAreaLT.print("LT");

   // 64pixel from left, 47 pixel from top, 2 columns, 1 line
   
  textAreaLGal.DefineArea(64, 47, 2, 1, fixednums7x15);
  

  GLCD.DrawRect(62,0,20,64); //Draw the area
  pinMode(leftWarnPin, OUTPUT); //pn mode for light
  digitalWrite(leftWarnPin, LOW); //turn pin to low



//Total fuel area*******************************************************************
  

  // 3pixel from left, 1 pixel from top, 5 columns, 2 line 
  textAreaFuel.DefineArea(3, 1, 5, 2 , newbasic3x5);
  textAreaFuel.print("TOTALFUEL:");

  // 45 pixel from left, 8 pixel from top, 5 columns, 2 line
  textAreaFuel.DefineArea(45, 8, 3, 1 , newbasic3x5);
  textAreaFuel.print("GAL");
  
   // 35pixel from left, 2 pixel from top, 2 columns, 1 line 
  textAreaTotal.DefineArea(26, 2, 2, 1, fixednums7x15);
  
  GLCD.DrawRect(0,0,60,19); //Draw the area


//Fuel Pressure area****************************************************************

  // 3 pixel from left, 22 pixel from top, 4 columns, 3 line 
  textAreaPSI.DefineArea(3, 22, 4, 3 , newbasic3x5);
  textAreaPSI.print("FUELPRESPSI:");
 
  
  // 25 pixel from left, 22 pixel from top, 2 columns, 1 line
  textAreaPRES.DefineArea(23, 22, 2, 1, lcdnums14x24);
  
 GLCD.DrawRect(0,19,60,30); //Draw the area

 // Endurence area******************************************************************

  // 3 pixel from left, 49 pixel from top, 3 columns, 2 line 
  textAreaEND.DefineArea(3, 49, 3, 2 , newbasic3x5);
  textAreaEND.print("ENDHRS");

 
 // 24 pixel from left, 50 pixel from top, 3 columns, 1 line 
  textAreaHours.DefineArea(24, 50, 3, 1 , Verdana12_bold);
  

 GLCD.DrawRect(0,49,60,15); //Draw the area
   
}

void loop()
{
  
//************************************************RIGHT SENSOR********************************************
  // read the value from the Right sensor:
  RsensorValue = analogRead(RsensorPin);
  
  RGallon = map(RsensorValue,55,960,0,22); //Map the analog input to 22 gallons
  
  if (RGallon < 0) //if the sensor sends a wrong reading this is the min for my tank
  { 
    RGallon = 0;
  }
  
  if (RGallon > 22) //if the sensor sends a wrong reading this is the max for my tank
  { 
    RGallon = 22;
  }
  if (RGallon < 5 && RGallon > 2) //If the tanks has between 3 and 4 gallons left
  {
     digitalWrite(rightWarnPin, HIGH); //turn warning light ON check closely from now on...
  }
  if (RGallon < 2 || RGallon > 5) //If the tanks has less than 2 and more than 5 gallons left
  {
     digitalWrite(rightWarnPin, LOW); //turn warning light OFF so that it does not bug me
  }
  
  textAreaRGal.ClearArea();
  textAreaRGal.print(RGallon); //print the Right tank fuel number

  GLCD.DrawVBarGraph(GLCD.Right-14, GLCD.Bottom-18, 10, -37, 1, 0, 22, RGallon);
 

 

 
 
 //*****************************************CENTER SENSOR*************************************************
 
  // read the value from the Center sensor:
  CsensorValue = analogRead(CsensorPin);
  
  CGallon = map(CsensorValue,55,960,0,29); //Map the analog input to 29 gallons
  if (CGallon < 0)
  { 
    CGallon = 0;
  }
  
  if (CGallon > 29)
  { 
    CGallon = 29;
  }
  if (CGallon < 30 && CGallon > 26) //If the tanks has between 25 and 29 gallons left
  {
     digitalWrite(centerWarnPin, HIGH); //turn warning light ON check closely from now on...
  }
  if (CGallon < 26) //If the tanks has less than 25 gallons left
  {
     digitalWrite(centerWarnPin, LOW); //turn warning light OFF so that it does not bug me
  }  
  
  
  textAreaCGal.ClearArea();
  textAreaCGal.print(CGallon); //print the Center tank fuel number

  GLCD.DrawVBarGraph(GLCD.Right-37, GLCD.Bottom-18, 10, -37, 1, 0, 29, CGallon);
 
 
 

 
 
  
 //**************************************LEFT SENSOR **********************************************************
 
  LsensorValue = analogRead(LsensorPin);
  
  LGallon = map(LsensorValue,55,960,0,22); //Map the analog input to 22 gallons
  if (LGallon < 0)
  { 
    LGallon = 0;
  }
  
  if (LGallon > 22)
  { 
    LGallon = 22;
  }
  
  if (LGallon < 5 && LGallon > 2) //If the tanks has between 3 and 4 gallons left
  {
     digitalWrite(leftWarnPin, HIGH); //turn warning light ON check closely from now on...
  }
  if (LGallon < 2 || LGallon > 5) //If the tanks has less than 2 and more than 5 gallons left
  {
     digitalWrite(leftWarnPin, LOW); //turn warning light OFF so that it does not bug me
  }
  
  textAreaLGal.ClearArea();
  
  textAreaLGal.print(LGallon); //print the Right tank fuel number
  
  
  GLCD.DrawVBarGraph(GLCD.Left+67, GLCD.Bottom-18, 10, -37, 1, 0, 22, LGallon);
  
  


//**********************************************FUEL PRESSURE******************************************



FsensorValue = analogRead(FsensorPin);
  
  PSI = map(FsensorValue,0,1024,0,60); //Map the analog input to 60 PSI since my plane is EFI I must use high pressure
  if (PSI < 0)
  { 
    PSI = 0;
  }
  
  if (PSI > 60)
  { 
    PSI = 60;
  }
 textAreaPRES.ClearArea();
 textAreaPRES.print(PSI); //print PSI

  
 
 //******************************************TOTAL AREA**********************************
 //TOTAL FUEL
  
  textAreaTotal.ClearArea();
  
  textAreaTotal.print(LGallon+RGallon+CGallon); //print the total fuel number
 



  
  //****************HOURS OF FUEL REMAINING (ENDURENCE)******************************
 
  

  totalfuel = LGallon+RGallon+CGallon;
  totalhrs = totalfuel/9; //based on 9 GPH fuel consuption
  textAreaHours.ClearArea();
  textAreaHours.print(totalhrs,1); //print the total endurence at 9 gph
  

 
 
 delay(500); // update every .5 seconds
 
 
}
